unit uDM;

interface

uses
  SysUtils, Classes, WideStrings, FMTBcd, DBClient, Provider, DB, SqlExpr,
  dialogs,DBXFirebird, ImgList, Controls;

type
  TDM = class(TDataModule)
    SQLConn: TSQLConnection;
    sqlParamEmail: TSQLDataSet;
    dspParamEmail: TDataSetProvider;
    cdsParamEmail: TClientDataSet;
    cdsParamEmailDESCRICAO: TStringField;
    cdsParamEmailASSUNTO: TStringField;
    cdsParamEmailCORPO: TStringField;
    cdsParamEmailNOME_REMETENTE: TStringField;
    cdsParamEmailREMETENTE: TStringField;
    cdsParamEmailCC: TStringField;
    cdsParamEmailCCO: TStringField;
    cdsParamEmailAVISO: TStringField;
    cdsParamEmailHOST: TStringField;
    cdsParamEmailLOGIN: TStringField;
    cdsParamEmailSENHA: TStringField;
    cdsParamEmailAUTENTICACAO: TStringField;
    sqlParamEmailSEQ_EMAIL: TIntegerField;
    sqlParamEmailDESCRICAO: TStringField;
    sqlParamEmailASSUNTO: TStringField;
    sqlParamEmailCORPO: TStringField;
    sqlParamEmailNOME_REMETENTE: TStringField;
    sqlParamEmailREMETENTE: TStringField;
    sqlParamEmailCC: TStringField;
    sqlParamEmailCCO: TStringField;
    sqlParamEmailAVISO: TStringField;
    sqlParamEmailHOST: TStringField;
    sqlParamEmailLOGIN: TStringField;
    sqlParamEmailSENHA: TStringField;
    sqlParamEmailAUTENTICACAO: TStringField;
    sqlParamEmailASSINATURA: TStringField;
    cdsParamEmailASSINATURA: TStringField;
    cdsParamEmailSEQ_EMAIL: TIntegerField;
    spEnviaEMail: TSQLStoredProc;
    sqlLogErro: TSQLDataSet;
    dspLogErro: TDataSetProvider;
    cdsLogErro: TClientDataSet;
    sqlLogErroSEQ_ENVIO_MENS: TIntegerField;
    sqlLogErroDT_ERRO: TDateField;
    sqlLogErroERRO: TStringField;
    sqlLogErroDT_CRIACAO: TDateField;
    sqlLogErroASSUNTO: TStringField;
    sqlLogErroCORPO: TStringField;
    sqlLogErroDESTINATARIO: TStringField;
    sqlLogErroSEQ_EMAIL: TIntegerField;
    cdsLogErroSEQ_ENVIO_MENS: TIntegerField;
    cdsLogErroDT_ERRO: TDateField;
    cdsLogErroERRO: TStringField;
    cdsLogErroDT_CRIACAO: TDateField;
    cdsLogErroASSUNTO: TStringField;
    cdsLogErroCORPO: TStringField;
    cdsLogErroDESTINATARIO: TStringField;
    cdsLogErroSEQ_EMAIL: TIntegerField;
    procedure cdsParamEmailAfterPost(DataSet: TDataSet);
    procedure cdsParamEmailReconcileError(DataSet: TCustomClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure DataModuleCreate(Sender: TObject);
    procedure cdsParamEmailAfterInsert(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure EnviaEMail(ASeqEMail : Integer; ACorpo,ADestinatario : String;
                         AAssunto : String = ''; ACC : String = ''; ACCO : String = '');

  end;

var
  DM: TDM;

implementation

{$R *.dfm}

procedure TDM.cdsParamEmailAfterInsert(DataSet: TDataSet);
begin
  cdsParamEmailAVISO.AsString        := 'N';
  cdsParamEmailAUTENTICACAO.AsString := 'S';
end;

procedure TDM.cdsParamEmailAfterPost(DataSet: TDataSet);
begin
  cdsParamEmail.ApplyUpdates(0);
end;

procedure TDM.cdsParamEmailReconcileError(DataSet: TCustomClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind; var Action: TReconcileAction);
begin
  MessageDlg('Falha ao gravar os dados.'+#13+#10+
             'Erro: '+e.Message, mtWarning, [mbOK], 0);
  Action := raCancel;
end;

procedure TDM.DataModuleCreate(Sender: TObject);
begin
  SQLConn.Params.LoadFromFile('conexao.ini');
end;

procedure TDM.EnviaEMail(
  ASeqEMail : Integer; ACorpo,ADestinatario : String;
  AAssunto : String = ''; ACC : String = ''; ACCO : String = '');
// insere na tab de envio de emails
Var
  sErro : String;
begin
  Try
    spEnviaEMail.ParamByName('ASEQ_EMAIL').Value    := ASeqEMail; // cod do parametro do e-mail
    spEnviaEMail.ParamByName('ACORPO').Value        := #13+#10+ACorpo;
    spEnviaEMail.ParamByName('ADESTINATARIO').Value := ADestinatario;
    If AAssunto <> '' Then
      spEnviaEMail.ParamByName('ASSUNTO').Value := AAssunto;
    if ACC <> '' then
      spEnviaEMail.ParamByName('ACC').Value := ACC;
    if ACCO <> '' then
      spEnviaEMail.ParamByName('ACCO').Value := ACCO;
    spEnviaEMail.ExecProc;
  Except
    On E : Exception Do
    Begin
      sErro := 'Falha ao criar o e-mail. Erro: '+e.Message;
      Raise Exception.Create(sErro);
    End;
  End;
end;

end.
