{
Programa: Executa.pas
Objetivo: Envio de mensagens
Autor: George De Luca
Data: 14/06/2010

Alteraes:

}
unit uExecuta;

interface

Uses
  StrUtils, DB, Classes, Sysutils, Forms, DBClient,
  IdSMTP;

  Type
    TProcesso = Class(TPersistent)
    Private
      Procedure EnviaMENS;
    Public
      Constructor Create; Overload;
  End;


implementation

uses uDM, uLog;

{ TProcesso }

constructor TProcesso.Create;
begin
  inherited Create;
  // inicia a atualizacao dos registros
  oLog.AddLinha('');
  oLog.Aviso('Inicio do envio das mensagens...');
  //dm.Envio2;
  EnviaMENS;
end;

procedure TProcesso.EnviaMENS;
Begin
  // Executo o SQl que contm as mensagens a serem enviadas
  dm.cdsEnvioMens.Close;
  dm.cdsEnvioMens.Open;
  while not dm.cdsEnvioMens.Eof do
  Begin
    // Usurio
    dm.IdSMTP.Username := dm.cdsEnvioMensLOGIN.AsString;
    // Senha
    dm.IdSMTP.Password := dm.cdsEnvioMensSENHA.AsString;
    // Servidor SMTP
    dm.IdSMTP.Host := dm.cdsEnvioMensHOST.AsString;
    // Autenticao
    dm.IdSMTP.AuthType := satNone;
    if not dm.IdSMTP.Connected then
      dm.IdSmtp.Connect;
    try
      if dm.cdsEnvioMensAUTENTICACAO.AsString = 'S' then
      Begin
        dm.IdSMTP.AuthType := satDefault;
        dm.IdSMTP.Authenticate;
      End;
      dm.IdMessage.From.Name    := dm.cdsEnvioMensNOME_REMETENTE.AsString;
      dm.IdMessage.From.Address := dm.cdsEnvioMensREMETENTE.AsString;
      if dm.cdsEnvioMensAVISO.AsString = 'S' Then
      Begin
        dm.IdMessage.ReceiptRecipient.Text := dm.IdMessage.From.Name;
      End;
      //
      dm.IdMessage.Subject := dm.cdsEnvioMensASSUNTO.AsString;
      // destinatario
      dm.IdMessage.Recipients.EMailAddresses := dm.cdsEnvioMensDESTINATARIO.AsString;
      // copia
      If dm.cdsEnvioMensCC.AsString <> '' Then
        dm.IdMessage.CCList.EMailAddresses := dm.cdsEnvioMensCC.AsString;
      // copia oculta
      If dm.cdsEnvioMensCCO.AsString <> '' Then
        dm.IdMessage.BccList.EMailAddresses := dm.cdsEnvioMensCCO.AsString;
      // corpo da mensagem
      dm.IdMessage.Body.Text := dm.cdsEnvioMensCORPO.AsString;
      // envia o e-mail
      dm.IdSMTP.Send(dm.IdMessage);
      // grava no log de execuo que foi enviado com sucesso
      oLog.Aviso(Format('Email %d enviado com sucesso.',[dm.cdsEnvioMensSEQ_ENVIO_MENS.AsInteger]));
      // desconecta
      dm.IdSMTP.Disconnect;
      // grava que enviou
      dm.cdsEnvioMens.Edit;
      dm.cdsEnvioMensIND_ERRO.AsString   := 'N';
      dm.cdsEnvioMensDT_ENVIO.AsDateTime := date;
      dm.cdsEnvioMens.ApplyUpdates(0);
    except
      On E : Exception Do
      Begin
        dm.IdSMTP.Disconnect;
        // grava no log de execuo que ocorreu erro ao enviar o e-mail
        oLog.Erro(Format('Falha ao enviar o e-mail %d. Erro: %s',[dm.cdsEnvioMensSEQ_ENVIO_MENS.AsInteger,e.Message]));
        // grava no log da mensagem que deveria ter sido enviada
        dm.sqlInsErro.Close;
        dm.sqlInsErro.Params.ParamByName('SEQ_ENVIO_MENS').Value := dm.cdsEnvioMensSEQ_ENVIO_MENS.AsInteger;
        dm.sqlInsErro.Params.ParamByName('DT_ERRO').Value        := date;
        dm.sqlInsErro.Params.ParamByName('ERRO').Value           := e.Message;
        dm.sqlInsErro.ExecSQL();
        // gravo que deu erro
        dm.cdsEnvioMens.Edit;
        dm.cdsEnvioMensIND_ERRO.AsString := 'S';
        dm.cdsEnvioMens.ApplyUpdates(0);
      End;
    End;
    // proximo registro
    dm.cdsEnvioMens.Next;
  End;
end;

end.

