unit uSenha;

interface

uses
  StrUtils, SysUtils;

type

  TCharType = (ctMaiscula, ctMinuscula, ctNumero, ctEspecial);

  TSenha = class
  private
    function CheckCharSenha(aSenha : string; aCharType : TCharType) : Boolean;
  public
    function ValidaSenha(aSenha : string) : string;
  end;

implementation

{ TSenha }

function TSenha.CheckCharSenha(aSenha: string; aCharType: TCharType): Boolean;
const
  cCharsMaiucula : set of char = ['A'..'Z', ''];
  cCharsMinuscula : set of char = ['a'..'z', ''];
  cCharsNumeros : set of char = ['0'..'9'];
  cCharsEspecial : set of char = ['\', '|','!', '@', '#', '$', '%', '', '&', '*', '(',
                    ')', '', '', '', '/', '-', '_', '+', '', '+', '=',
                    '', '`', '"', '''', '{', '}', '[', ']', '', '', '~',
                    '^', ':', ';', ',', '.', '<', '>', '?', ''];
var
  I : Integer;
  vConstType : set of char;
begin
  Result := False;

  case aCharType of
    ctMaiscula: vConstType := cCharsMaiucula;
    ctMinuscula: vConstType := cCharsMinuscula ;
    ctNumero: vConstType := cCharsNumeros;
    ctEspecial: vConstType := cCharsEspecial;
  end;

  for I := 1 to Length(aSenha) do begin
    if (aSenha[I] in vConstType) then begin
      Result := True;
      Break;
    end;
  end;
end;

function TSenha.ValidaSenha(aSenha: string): string;
begin
  if (Trim(aSenha) <> EmptyStr) then begin
    if (Length(aSenha) >= 6) then begin
      if Self.CheckCharSenha(aSenha, ctMaiscula) then begin
        if Self.CheckCharSenha(aSenha, ctMinuscula) then begin
          if Self.CheckCharSenha(aSenha, ctNumero) then begin
            if Self.CheckCharSenha(aSenha, ctEspecial) then begin
              Result := 'Senha vlida';
            end
            else begin
              Result := 'Sem caracteres especiais';
            end;
          end
          else begin
            Result := 'Sem numerais';
          end;
        end
        else begin
          Result := 'Sem letras minsculas'
        end;
      end
      else begin
        Result := 'Sem letras maisculas';
      end;
    end
    else begin
      Result := 'No atingiu o mnimo de 6 caracteres';
    end;
  end
  else begin
    Result := 'Senha inexistente';
  end;
end;

end.
